<?php

class paspayment2validationModuleFrontController extends ModuleFrontController
{
    public function postProcess()
    {
        $cart = $this->context->cart;

        if ($cart->id_customer == 0 || $cart->id_address_delivery == 0 || $cart->id_address_invoice == 0 || !$this->module->active) {
            Tools::redirect('index.php?controller=order&step=1');
        }
        $authorized = false;
        foreach (Module::getPaymentModules() as $module) {
            if ($module['name'] == 'paspayment2') {
                $authorized = true;
                break;
            }
        }

        if (!$authorized) {
            die($this->trans('This payment method is not available.', array(), 'Modules.paspayment2.Shop'));
        }

        $customer = new Customer($cart->id_customer);

        if (!Validate::isLoadedObject($customer)) {
            Tools::redirect('index.php?controller=order&step=1');
        }

        $currency = $this->context->currency;
		
		$total1 = (float)$cart->getOrderTotal(true, Cart::BOTH);
  
		$purchase_currency = new Currency(Currency::getIdByIsoCode('IRR'));			
		$OrderDesc = Configuration::get('PS_SHOP_NAME'). $this->l(' Order');
		$current_currency = new Currency($this->context->cookie->id_currency);
		if($current_currency->id == $purchase_currency->id)
		$total= number_format($cart->getOrderTotal(true, 3), 0, '', '');		 
		else
		$total= number_format(Tools::convertPrice($cart->getOrderTotal(true, 3), $purchase_currency), 0, '', '');	

		
		$orderId = Tools::getValue('paid');
        $order = new Order($orderId);
		if( isset($_POST['respcode']) && $_POST['respcode'] == '0' )
		{
			$terminal =trim(Configuration::get('PAS2_TER'));
			
			$sql = "SELECT COUNT(*) FROM `"._DB_PREFIX_."message` WHERE `message`  LIKE '%".$_POST['digitalreceipt']."%'";
			$ress =  Db::getInstance()->getValue($sql);
		
			if($ress == 0)
			{
				$params ='digitalreceipt='.$_POST['digitalreceipt'].'&Tid='.$terminal;
				$ch = curl_init();
				curl_setopt($ch, CURLOPT_URL, 'https://mabna.shaparak.ir:8081/V1/PeymentApi/Advice');
				curl_setopt($ch, CURLOPT_POSTFIELDS, $params);
				curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
				$res = curl_exec($ch);
				curl_close($ch);
				$result = json_decode($res,true);
				 if (strtoupper($result['Status']) == 'OK') 
				 {
					 
					if( floatval($result['ReturnId']) == floatval($total) )
					{
						$referenceId = $_POST['digitalreceipt'];
						$this->module->validateOrder((int)$cart->id, _PS_OS_PAYMENT_, $total1, $this->module->displayName, "سفارش تایید شده / کد رهگیری :".$referenceId,array(), (int)$currency->id, false, $customer->secure_key);
						Tools::redirect('index.php?controller=order-confirmation&id_cart='.(int)$cart->id.'&id_module='.(int)$this->module->id.'&id_order='.$this->module->currentOrder.'&key='.$customer->secure_key);
					
					}
					else
					{
						$message ='مبلغ واریزی با قیمت محصول برابر نیست';
					}
					 
				}else
				{
					$message ='خطا در وریفای اطلاعات.';
				}
		   }
			else
			{
				echo $paspayment2->error($paspayment2->l('رسید قبلا استفاده شده است'));
			}
		}
		else
		{
			$message = 'برگشت ناموفق از درگاه';
		}
		
		
		 if ((bool)Context::getContext()->customer->is_guest) {
				$url=Context::getContext()->link->getPageLink('guest-tracking', true);
			} else {
				$url=Context::getContext()->link->getPageLink('history', true);
			}
			
		 $this->context->smarty->assign([
				'message' => $message,
				'redirectUrl' => $url,
				'orderReference' => $order->reference,

			]);
			
			return $this->setTemplate('module:paspayment2/back.tpl');
    }
	
}
